#include "stdio.h"
#include "conio.h"
#include "omp.h"

//#define VERSION1
#define VERSION2

#ifdef VERSION1
// ---------------------------------------------------------------------------
const int NUM_THREADS = 4;

int main(int argc, char *argv[])
{
  #pragma omp parallel num_threads(NUM_THREADS)
  {
    printf("Hello World from thread %d\n", omp_get_thread_num());
    if (omp_get_thread_num() == 0)
      printf("Number of threads = %d\n", omp_get_num_threads());
  }

  getch();

  return 0;
}
#endif

#ifdef VERSION2
const int NUM_THREADS = 10;

// ---------------------------------------------------------------------------
int main(int argc, char *argv[])
{
  int th_num[NUM_THREADS + 1];
  int i;

  for (i = 1; i < NUM_THREADS; i++)
    th_num[i] = 0;
  th_num[0] = 1;

  #pragma omp parallel num_threads(NUM_THREADS)
  {
    int rank = omp_get_thread_num();
    while(th_num[rank] == 0)
      ;
    printf("Hello World from thread %d\n", rank);
    th_num[rank + 1]++;
    if (rank == 0)
      printf("Number of threads = %d\n", omp_get_num_threads());
  }

  getch();

  return 0;
}
#endif
// - end of file -------------------------------------------------------------
