#include "omp.h"
#include "stdio.h"

const int Size = 10;

//#define V1
#ifndef V1
//#define V2
#ifndef V2
//#define V3
#ifndef V3
#define V4
#endif
#endif
#endif

#ifdef V1
//int mas[Size];

int main(int argc, char *argv[])
{
  int mas[Size];
  int i;

  omp_set_num_threads(2);
  #pragma omp parallel firstprivate(mas)
  {
    if (omp_get_thread_num() == 1)
    {
      printf("\n");
      for (i = 0; i < Size; i++)
        printf("mas[%d] = %d\n", i, mas[i]);
    }
  }

  return 0;
}
#endif

#ifdef V2
int main(int argc, char *argv[])
{
  int mas[Size];
  int i;

  for (i = 0; i < Size; i++)
    mas[i] = i;

  omp_set_num_threads(2);
  #pragma omp parallel firstprivate(mas)
  {
    if (omp_get_thread_num() == 1)
    {
      printf("\n");
      for (i = 0; i < Size; i++)
        printf("mas[%d] = %d\n", i, mas[i]);
    }
  }

  return 0;
}
#endif

#ifdef V3
int main(int argc, char *argv[])
{
  int mas[Size];
  int i;

  omp_set_num_threads(2);
  #pragma omp parallel // firstprivate(mas)
  {
    #pragma omp for // firstprivate(mas)
    for (i = 0; i < Size; i++)
      mas[i] = i;

    #pragma omp for firstprivate(mas)
    for (i = 0; i < Size; i++)
      printf("%d mas[%d] = %d\n", omp_get_thread_num(), i, mas[i]);
  }

  return 0;
}
#endif

#ifdef V4
int gmas[Size];

#pragma omp threadprivate(gmas)

int main(int argc, char *argv[])
{
  int mas[Size];
  int i;

  for (i = 0; i < Size; i++)
  {
    mas[i] = i;
  }

  omp_set_num_threads(2);

  #pragma omp parallel firstprivate(mas)// copyin(mas)
  {
    if (omp_get_thread_num() == 0)
    {
      for (i = 0; i < Size; i++)
        gmas[i] = i;
    }
  }

  #pragma omp parallel copyin(gmas)
  {
    if (omp_get_thread_num() == 0)
    {
      printf("\n");
      for (i = 0; i < Size; i++)
        printf("gmas[%d] = %d\n", i, gmas[i]);
    }
  }

  return 0;
}
#endif
